#!/usr/bin/perl -w

use MIME::Base64 ();

my $ctrl_p = chr(ord('P') & 037);
#--------------------------------------------------------------------
my $win_sz = 20;

my %val_w_keys;
my @val_list;
my $prefix_len;

my %uncomplete_prefix;
my %uncomplete_prefix_next;
my %for_save;
my $deleted = 0;

#--------------------------------------------------------------------
sub keylist {
  my @rc;
  my $line = $_[0]; 
  $line =~ s/^\s*//;
  do {
    push(@rc, $line);
    $line =~ s/^\W*\w+\W*//;
  } while(length $line);  
  return @rc;
}
#--------------------------------------------------------------------
sub save_ln {
  my($key, $val, $weight) = split(/\s*\t\s*/, $_[0]);
  @{$val_w_keys{$val}}[0] += $weight;
  push(@{$val_w_keys{$val}}, $key);
}

#--------------------------------------------------------------------

sub download {
  my ($key, $vals, $complete_flag) = @_;
  my $cli_flag = 0; # No from begin
  $cli_flag |= 1 if($complete_flag);
  my $srv_flag = 0; # No match_begin
  # 4- for zip - skipped
  $srv_flag |= 1 unless($complete_flag);
  
  print "$key$ctrl_p$srv_flag";
  
  foreach my $v (@{$vals}) {
    my @orig_keys = @{$val_w_keys{$v}};
    $orig_keys[0] = ""; #Replace WEIGHT to "" for first @ at out
    my $outline  = "|$v" . join("\@", @orig_keys);
    $outline =~ s/\"/\\\"/g;
    print $outline;
  }
  
  print "\n";
  
}

#--------------------------------------------------------------------

sub save_out {
  my ($prefix, $val) = @_;
  my $fs = $for_save{$prefix};
  
  return if(defined $fs && $fs == -1);
  
  if(defined $fs && scalar @{$fs} >= $win_sz) {
    &download($prefix, $for_save{$prefix}, 0);
    $for_save{$prefix} = -1;
    $uncomplete_prefix_next{$prefix} = 1;
  } else {
    push(@{$for_save{$prefix}}, $val);
  }
}

#--------------------------------------------------------------------
sub sq_val_list {
  my $w_ndx = 0;
  print STDERR "Squizee: Old sz=" . scalar(@val_list);
  foreach my $v (@val_list) {
    $val_list[$w_ndx++] = $v if defined $v;
  }
  splice(@val_list, $w_ndx);
  $deleted = 0;
  print STDERR "; Squized=$w_ndx\n";
}

#--------------------------------------------------------------------
sub cmp_keys_w {
 my $rc = @{$val_w_keys{$b}}[0] <=> @{$val_w_keys{$a}}[0];
 return $rc == 0? $a cmp $b : $rc; 
}

#--------------------------------------------------------------------


my $c = 100;
while(<>) {
  chomp;
  &save_ln($_);
  #last unless(--$c);
}

print STDERR "Load #" . scalar(keys %val_w_keys) . " lines\n";

while(my ($val, $list) = each %val_w_keys) {
  my ($w, @l) = @{$list};
  $w = int($w / scalar(@l)); #correction weight for dups
  my %lh;
  foreach (@l) {
    $lh{lc($_)} = 1;
  }
  delete $lh{lc($val)};
  @{$val_w_keys{$val}} = ($w, keys %lh);
}

print STDERR "Start sorting\n";

@val_list = sort cmp_keys_w keys %val_w_keys;

#foreach my $val (@val_list) {
#  print "$val -> " . join("|", @{$val_w_keys{$val}}) . "\n";
#}

$uncomplete_prefix{""} = 1;

for($prefix_len = 1; scalar(keys %uncomplete_prefix); $prefix_len++) {
  print STDERR "prefix_len=$prefix_len; Uncomp=" . 
    scalar(keys %uncomplete_prefix) . "; Del=$deleted\n";
  undef %uncomplete_prefix_next;
  undef %for_save;
  
  for(my $val_ndx = 0;  $val_ndx < scalar @val_list; $val_ndx++) {
    my $val = $val_list[$val_ndx];
    next unless defined $val;
    my $can_delete = 1;
    my ($w, @keylist) = @{$val_w_keys{$val}};
    my %lh_prefix;
    foreach my $orig_key (lc($val), @keylist) {
      foreach my $key (&keylist($orig_key)) {
        next if(length($key) < $prefix_len);
        my $parent_prefix = substr($key, 0, $prefix_len - 1);
        if(defined $uncomplete_prefix{$parent_prefix}) {
          $can_delete = 0;
          my $cur_prefix = substr($key, 0, $prefix_len);
          unless(defined $lh_prefix{$cur_prefix}) {
            save_out($cur_prefix, $val);
            $lh_prefix{$cur_prefix} = 1;
          } 
        }
      } #foreach my $key(&keylist($orig_key))
    } # foreach $orig_key (@keylist)
    if($can_delete) {
      undef $val_list[$val_ndx];
      delete $val_w_keys{$val}; # Too slowly 
      ++$deleted;
    }
  } # foreach my $val(@val_list)
  
  %uncomplete_prefix = %uncomplete_prefix_next;
  
  while(my ($k, $v) = each %for_save) {
    &download($k, $v, 1) if($v != -1);
  }
  sq_val_list() if (($deleted << 3) > (scalar(@val_list) + 2000));
} #for($prefix_len = 1; scalar(keys %uncomplete_prefix); $prefix_len++)

print STDERR "Completed OK\n";

#--------------------------------------------------------------------
    ###next if($last_pos >= length $file[$lo]);
